//--------------------------------------------------------------------------
//
//  Conditional compile definition symbols:
//    DEBUG      - collect and exhibit extra information for debugging
//
// 	(C) 1993,94 by Radicon Ltd.
//--------------------------------------------------------------------------
#include		<stdio.h>
#include 		"dfkisl.h"
#include 		"prkmpt1.h"
#include 		"radicon.h"

extern int 	FakeDevice;
extern int 	FakeData;

#ifdef DEBUG
extern int 	retspot_set;
extern int 	retspot_beg;
extern int 	retspot_get;
extern int 	retspot_init;
extern int 	retspot_tr;
extern int 	retspot_rc;
extern int 	retspot_out;
extern int 	retspot_in;
#endif //def DEBUG

//-SNUchar bufprg[LNGPRG];
unsigned char	bufprg[LNGPRG];                //+SNU
unsigned char	bufmsg[LNGMSG];  /* buffer receive/transmit message */

/************************************************
 *             --- int far setprm ---
 *  loading parameters to controller
 * return:
 *  0 o'key
 * -1 communication error
 * -2 controller can't make this function to
 * present time or error code function
 * -3 parameter error
 ************************************************/
#ifdef DEBUG
int retspot_set;
#endif //def DEBUG

int CALLTYPE setprm(rd,rs,cph,cpl,ve,ftmr,imp,intg,snd,ntrp)
int   rs,           /* status register */
			rd;           /* data register */
//-SNUunsigned  cph,      /* DAC: upper threshold */
unsigned short cph,      /* DAC: upper threshold */                    //+SNU
					cpl;      /* DAC: lower threshold */
int ve;             /* high voltage */
double ftmr;        /* exposure time */
unsigned long imp;  /* pulse number */
int intg;           /* energy integral */
int snd;            /* sound */
int ntrp;           /* interrupt */
{
register int i,j;
unsigned long wtmr;
//unsigned char bufmsg[LNGMSG];  /* buffer receive/transmit message */

#ifdef DEBUG
		retspot_set = retspot_beg = retspot_get = retspot_init = retspot_tr =
			retspot_rc = retspot_out = retspot_in = 0;
#endif //def DEBUG

		if (FakeDevice)
			return 0;

		bufmsg[0]=(unsigned char)intg;

		bufmsg[1]=(unsigned char)snd;

		bufmsg[7]=(unsigned char)ve;
		ve=(ve >> 8) & 0xff;
		bufmsg[8]=(unsigned char)ve;

		bufmsg[9]=(unsigned char)cpl;
		cpl=(cpl >> 8) & 0xff;
		bufmsg[10]=(unsigned char)cpl;

		bufmsg[11]=(unsigned char)cph;
		cph=(cph >> 8) & 0xff;
		bufmsg[12]=(unsigned char)cph;

		wtmr=ftmr * KMGHZ;
		bufmsg[13]=(wtmr & 0xff);
		bufmsg[14]=((wtmr >> 8) & 0xff);
		bufmsg[15]=(wtmr >> 16) & 0xff;
		bufmsg[16]=(wtmr >> 24) & 0xff;

		bufmsg[17]=(imp & 0xff);
		bufmsg[18]=((imp >> 8) & 0xff);
		bufmsg[19]=(imp >> 16) & 0xff;
		bufmsg[20]=(imp >> 24) & 0xff;

		bufmsg[21]=(ntrp & 0xff);

		for (i=0; i < NCYCL; i++) {
			j=tr_message(CF0,rd,rs,bufmsg,LNGMSG_TR);
			if (j == 0) break;
			if (j == -2)
				{
#ifdef DEBUG
					retspot_set = 1;
#endif //def DEBUG
					return -2;
				}
		}
		if (j != 0)
			{
#ifdef DEBUG
				retspot_set = 2;
#endif //def DEBUG
				return -1;
			}
#ifdef DEBUG
		retspot_set = 0;
#endif //def DEBUG

		return 0;
}



/************************************************
 *             --- int begwrk ---
 *  make work (function code)
 * return:
 *  0 o'key
 * -1 communication error
 * -2 controller can't make this function to
 * present time or error code function
 * -3 parameter error
 ************************************************/
#ifdef DEBUG
int retspot_beg;
#endif //def DEBUG

int CALLTYPE begwrk(fun,rd,rs)
int   fun,          /* function code */
			rs,           /* register of state */
			rd;           /* register of data */
{
register int i,j;
//-SNUchar bufmsg[LNGMSG];  /* buffer of receive/transmit message */
unsigned char bufmsg[LNGMSG];/* buffer of receive/transmit message */  //+SNU

#ifdef DEBUG
retspot_set = retspot_beg = retspot_get = retspot_init = retspot_tr =
	retspot_rc = retspot_out = retspot_in = 0;
#endif //def DEBUG

if (FakeDevice)
	return 0;

switch (fun) {

	case  1 :   /* count pulses during exposure time */
	case  2 :   /* count time when number of pulses is set */
	case  3 :   /* intensimeter */
	case  5 :   /* stop controller */

		for (i=0; i < NCYCL; i++) {
			j=tr_message(fun,rd,rs,bufmsg,0);
			if (j == 0) break;
			if (j == -2)
				{
#ifdef DEBUG
					retspot_beg = 1;
#endif //def DEBUG
					return -2;
				}
		}

		if (j != 0)
			{
#ifdef DEBUG
				retspot_beg = 2;
#endif //def DEBUG
				return -1; /* error */
			}
#ifdef DEBUG
		retspot_beg = 0;
#endif //def DEBUG
		return 0;

	default :
#ifdef DEBUG
		retspot_beg = 3;
#endif //def DEBUG
		return -3;

}
}

/************************************************
 *             --- int getinf ---
 *  get information from controller
 * return:
 *  0 o'key
 * -1 error communication
 * -2 function reject
 * -3 error parameter
 * -4 data isn't ready
 ************************************************/
#ifdef DEBUG
int retspot_get;
#endif //def DEBUG

int CALLTYPE getinf(fun,rd,rs,ftmr,imp)
int   fun,  /* function code */
			rd,  /* data register */
			rs;  /* state register */

double * ftmr;  /* time */

unsigned long * imp;  /* pulses */

{
register int i,j;
double wftmr;
unsigned long wimp,wtmr,ww;
unsigned char * p;
int l;
unsigned char bufmsg[LNGMSG];  /* buffer receive message */

#ifdef DEBUG
retspot_set = retspot_beg = retspot_get = retspot_init = retspot_tr =
	retspot_rc = retspot_out = retspot_in = 0;
#endif //def DEBUG

if (FakeDevice)
	{
		*ftmr = 0.0;
		*imp  = 0;
		return 0;
	}

switch (fun) {

	case  9     :  /* receive result time and pulses */
	case  0x0b  :  /* receive current time and pulses */

		for (i=0; i < NCYCL; i++) {
			l=0;
			j=rc_message(fun,rd,rs,bufmsg,LNGMSG,&l);
			if (j == 0) break;
			if (j == -2)
				{
#ifdef DEBUG
					retspot_get = 1;
#endif //def DEBUG
					return -2;
				}
			if (j == -4)
				{
#ifdef DEBUG
					retspot_get = 2;
#endif //def DEBUG
					return -4;
				}
		}

		if (j != 0)
			{
#ifdef DEBUG
				retspot_get = 3;
#endif //def DEBUG
				return -1; /* error communicate */
			}

		p=bufmsg;

		wtmr=0;

		ww=0;
		ww=*p;
		wtmr=wtmr+ww;
		p++;

		ww=0;
		ww=*p;
		ww=ww << 8;
		wtmr=wtmr+ww;
		p++;

		ww=0;
		ww=*p;
		ww=ww << 16;
		wtmr=wtmr+ww;
		p++;

		ww=0;
		ww=*p;
		ww=ww << 24;
		wtmr=wtmr+ww;
		p++;

		wftmr=wtmr;
		*ftmr=wftmr/(KMGHZ);

		wimp=0;

		ww=0;
		ww=*p;
		wimp=wimp+ww;
		p++;

		ww=0;
		ww=*p;
		ww=ww << 8;
		wimp=wimp+ww;
		p++;

		ww=0;
		ww=*p;
		ww=ww << 16;
		wimp=wimp+ww;
		p++;

		ww=0;
		ww=*p;
		ww=ww << 24;
		wimp=wimp+ww;

		*imp=wimp;

#ifdef DEBUG
		retspot_get = 0;
#endif //def DEBUG
		return 0;


	default :
#ifdef DEBUG
		retspot_get = 4;
#endif //def DEBUG
		return -3;

 }
}


/************************************************
 *            --- int init_b ---
 *  load programm to monitor
 * return:
 * 0    - o'key
 * -1   - communication error
 * -2   - controller reject connect
 * -3   - file length biggest then
 * maximum length
 ************************************************/
#ifdef DEBUG
int retspot_init;
#endif //def DEBUG

int CALLTYPE init_b (unsigned char * pBuf, unsigned int BufSize, int rd, int rs)
{
	register int i,j;
	int d;

#ifdef DEBUG
	retspot_set = retspot_beg = retspot_get = retspot_init = retspot_tr =
		retspot_rc = retspot_out = retspot_in = 0;
#endif //def DEBUG

	if (FakeDevice)
		return 0;

	if (BufSize > LNGPRG) { /* file biggest then LNGPRG byte */
		{
#ifdef DEBUG
			retspot_init = 1;
#endif //def DEBUG
			return -3;
		}
	}

	i=crnt_time();

	while (1) { /* timeout after reset controller: TMOUT * 50 msecond */
		j=crnt_time();
		if (j - i < 0) i=j;
		if (j - i > TMOUT) break;
	}

#ifndef __WIN32__
	_asm { /* d=inp(rd); */
		sub ax,ax     ;
		mov dx,rd     ;
		in  al,dx     ;
		mov d,ax      ;
	}
#endif

	begwrk(CF5,rd,rs); /* stop process */

	for (i=0; i < NCYCL; i++) {
		j=tr_message(CFF,rd,rs,pBuf,BufSize);
		if (j == -2)
			{
#ifdef DEBUG
				retspot_init = 2;
#endif //def DEBUG
				return -2;
			}
		if (j == 0) break;
	}

	if (i == NCYCL)
		{
#ifdef DEBUG
			retspot_init = 3;
#endif //def DEBUG
			return -1;
		}

	if (d == MONIT) {
		i=in_byte(rd,rs,&d);
		if (d == PROGR)
			{
#ifdef DEBUG
				retspot_init = 0;
#endif //def DEBUG
				return 0;
			}
	}
#ifdef DEBUG
	retspot_init = 0;
#endif //def DEBUG

	return 0;
}

/************************************************
 *             --- int reset ---
 *  reset controller
 ************************************************/
void CALLTYPE reset(rs)
 int rs;   /* state register */
{
	if (FakeDevice)
		return;

#ifndef __WIN32__
	_asm {
		mov dx,rs     ;
		out dx,al     ;
	}
#endif
  }
// __LastLine__
