#ifndef __M_LAYER_H
#define __M_LAYER_H

#ifdef __cplusplus
extern "C" {
#endif
// prototypes for export functions
BOOL 			WINAPI    mlInitializeMotorsDLL				(void);
BOOL 			WINAPI    mlSetAxis					      		(int);
int  			WINAPI    mlGetAxis					      		(void);
int		  	WINAPI    mlGetIdByName    						(TAxisType);
BOOL	  	WINAPI    mlGetDistance    						(int,double&);
double		WINAPI		mlGetValue								 	(int,TValueType);
BOOL 			WINAPI    mlMoveToDistance 						(int,double);
BOOL 			WINAPI    mlIsMoveFinish							(int);
double		WINAPI		mlGetOffset									(int);
TAxisType	WINAPI    mlParsingAxis								(LPSTR);

BOOL			WINAPI		mlIsAxisValid								(TAxisType);
BOOL 			WINAPI    mlIsServerOK								(void);
void			WINAPI		mlInquireReferencePointDlg	(int);
int				WINAPI		mlGetAxisNumber							(void);
void			WINAPI		mlPositionControlDlg				(void);
void			WINAPI		mlSetParametersDlg					(void);
void			WINAPI		mlSaveModuleSettings				(void);
void			WINAPI		mlSetAngleDefault						(void);
void			WINAPI		mlOptimizingDlg							(void);
LPCSTR  	WINAPI    mlGetVersion								(void);
HINSTANCE WINAPI    mlGetInstance								(void);

BOOL 			WINAPI    mMoveToDistance 						(double);
BOOL 			WINAPI    mMoveByDistance 						(double);
BOOL 			WINAPI    mSetLine										(int,BOOL);
BOOL 			WINAPI    mIsMoveFinish								(void);
BOOL 			WINAPI    mIsRangeHit									(void);
BOOL 			WINAPI    mIsCalibrated								(void);
BOOL 			WINAPI 		mIsDistanceRelative					(void);
void			WINAPI		mStopDrive									(BOOL);
BOOL 			WINAPI    mGetDistance				    		(double&);
double 		WINAPI 		mGetDistanceProcess					(void);
double		WINAPI		mGetValue										(TValueType);
TUnitType WINAPI		mGetUnitType								(void);
BOOL			WINAPI		mSetValue										(TValueType,double);
void    	WINAPI    mActivateDrive							(void);
void    	WINAPI    mSetCorrectionState					(BOOL);
LPCSTR  	WINAPI    mGetAxisName     						(void);
LPCSTR  	WINAPI    mGetAxisUnit     						(void);
LPCSTR  	WINAPI    mGetDF											(void);
LPCSTR  	WINAPI    mGetSF											(void);
void			WINAPI		mSetAngleDefault						(void);
void 			WINAPI 		mSetRelativeZero						(BOOL,double);
int				WINAPI		mExecuteCmd									(LPSTR);
void			WINAPI		mPushSettings								(void);
void			WINAPI		mPopSettings								(TMParameter);

int 			WINAPI    mGetMoveFinishIdx						(void);
void    	CALLBACK  mSavePosition          			(UINT,UINT,DWORD,DWORD,DWORD);
int 			WINAPI    mGetScanSize								(void);
LPLONG 		WINAPI    mGetMoveScan								(void);
void    	WINAPI    mStartMoveScan         			(int,int);
#ifdef __cplusplus
	}
#endif

#ifdef __WIN32__
typedef BOOL 		WINAPI    (*TInitializeMotorsDLL) (void);
typedef BOOL 		WINAPI    (*TSetAxis)             (int);
typedef int  		WINAPI    (*TGetAxis)					    (void);
typedef BOOL 		WINAPI    (*TSetLine)							(int,BOOL);
typedef BOOL 		WINAPI    (*TIsMoveFinish)				(void);
typedef BOOL 		WINAPI    (*TGetDistance)				  (double&);
typedef BOOL 		WINAPI    (*TIsServerOK)		 			(void);
typedef BOOL 		WINAPI    (*TMoveToDistance) 			(double);
typedef BOOL 		WINAPI    (*TMoveByDistance) 			(double);
typedef BOOL    WINAPI    (*TSetAxisWithName)     (TAxisType);
typedef int 		WINAPI    (*TGetScanSize)					(void);
typedef LPLONG 	WINAPI    (*TGetMoveScan)					(void);
typedef void    WINAPI    (*TStartMoveScan)       (int,int);
typedef int 		WINAPI    (*TGetMoveFinishIdx)		(void);
typedef void    CALLBACK  (*TSavePosition)        (UINT,UINT,DWORD,DWORD,DWORD);

typedef struct
	{
	public:
	TInitializeMotorsDLL  InitializeMotorsDLL;
	TSetAxis	            SetAxis;
	TSetAxisWithName      SetAxisWithName;
	TGetAxis	            GetAxis;
	TGetScanSize	        GetScanSize;
	TGetMoveScan          GetMoveScan;
	TStartMoveScan        StartMoveScan;
	TMoveToDistance       MoveToDistance;
	TMoveByDistance       MoveByDistance;
	TSetLine              SetLine;
	TIsMoveFinish         IsMoveFinish;
	TGetDistance          GetDistance;
	TIsServerOK           IsServerOK;
	TGetMoveFinishIdx     GetMoveFinishIdx;
	TSavePosition         SavePosition;
	} TMFunctionTable;
#endif
#endif
// __LastLine__

