// (C) Copyright 1995 by Heiko Damerow MPG AG "Rntgenbeugung"
// Datei offline.h
#ifndef __M_LSCAN_H
#define __M_LSCAN_H

#include		"m_data.h"

class TBitmap : public TMDIWindow
	{
	public:           TBitmap(void);
	virtual	  				~TBitmap(void) {};
	BOOL              ProcessBitmapFile(HFILE);
	void              FormatDBaseToBitmapSource(void);
	void              UpdateBitmapSource(void);
	virtual	BOOL 			New(void);

	protected:
	BITMAPFILEHEADER  BMPFileHdr;
	void              LoadBitmap(HDC);
	DWORD             GetImageSize(BITMAPINFOHEADER &);
	void              DrawBitmapFrame(HDC,BOOL);
	void              FillBMInfoFromPalette(LOGPALETTE *);
	void              DoCopy(void);
	void              RenderFormat(WPARAM);
	void              RenderAllFormats(WPARAM);
	void              DrawBitmap(HDC,int,int);
	HBITMAP           CreateGDIObject(HDC);
	HGLOBAL           RenderDIB(void);
	LOGPALETTE *      GetPalette(void);
	LOGPALETTE *      CreatePaletteFromDIB(void);
	LOGPALETTE *      CreateDefaultPalette(void);
	float             KoorXMin,KoorXMax;
	float             KoorYMin,KoorYMax;
	double            KoorSFX,KoorSFY;

	private:
	HGLOBAL           hDIBInfo;
	HGLOBAL						hDIBData;
	HGLOBAL						hMemPal;
	HPALETTE          hPalette,hOldPalette;
	HBITMAP           hBitmap;
	};

class TOffLineScan : public TBitmap
	{
  friend class    TScanArea;

	public:         TOffLineScan(void);
									~TOffLineScan();
	void            Size(HWND,WPARAM,LPARAM) {};
	void            Paint(HDC,PAINTSTRUCT *);
	void            lButtonDown(WPARAM,LPARAM);
	void            MouseMove(WPARAM,LPARAM);
	void            lButtonUp(WPARAM,LPARAM);
	BOOL            SaveFileAs(void);
	void						PickUpData(LPARAM) {};
	void            FreezeCurve(void) {};
	void            CounterSetRequest(LPARAM);
	void            DistanceSetRequest(LPARAM);
	BOOL 						SaveFile(int ask);
	BOOL 						UpdateFile(void);
	BOOL 						SaveReport(void);
	void            Interrupt(void);
	BOOL 						LoadOldData(int);
	void            SendCurve(void);
	BOOL 						New(void);
	void 						SteeringReady(LPARAM);
	void 						InitializeTask(WPARAM,LPARAM);
  void            InitializeDlg(WPARAM,LPARAM);
	void						EnablePaint(void) { bEnablePaint = TRUE;};
	void						DisablePaint(void) { bEnablePaint = FALSE;};

	protected:
	void 						rButtonDown(LONG lParam);
	BOOL 						CanOpen(void);
	BOOL 						CanClose(void);
	void 						Create(HWND hwnd);
	BOOL 						SetTitle(void);
	void  					UpdateWnd(int act);
	void    				SetRanges(void);
	float						GetXOffset(int) {return 0.0;};
	float						GetYOffset(int) {return 0.0;};
	HCURSOR         GetCursor(void) {return LoadCursor(NULL,IDC_CROSS);};
	HFONT           hFont;
	int							nActiveScan;
	TScannerTask		eScanTask;

	private:
	BOOL						bEnablePaint;
	void            DrawKoorSystem(HDC,BOOL);
	BOOL            bButtonDown;
	HDC             DragDC;
	};

class TScanArea
  {
  public:         TScanArea(TOffLineScan*);
                  ~TScanArea(void);
  BOOL            SetScanArea(HDC);

  private:
  TOffLineScan*   ScanWnd;
  LPBYTE          lpBackData;
  int             x0,y0,x1,y1;
  };


class TCrossTableControl : public TModalDlg
	{
	public:         TCrossTableControl();
	int             GetBarEgde(int,int);
	int             GetBarPos(int);
	void            Dlg_OnHScroll(HWND,HWND,UINT,int);
	void            Dlg_OnVScroll(HWND,HWND,UINT,int);
	BOOL            Dlg_OnInit(HWND,HWND,LPARAM);
	void            Dlg_OnTimer(HWND,UINT);
	void            Dlg_OnCommand(HWND,int,HWND,UINT);
	BOOL            LeaveDialog(void);

	private:
	int             AskTime;
  BOOL            bInitOk;
	BOOL            bStepMode;
	BOOL            bMoveActive;
	HWND            XBarHandle;
	HWND            YBarHandle;
	int             XBarFactor;
	int             YBarFactor;
	BOOL						bLongMove;
	int							nX_Axis;
	int							nY_Axis;
	double          *MoveSpeed;
	};
#endif
// __LastLine__
