#include	"rc_def.h"
#include	"comhead.h"
#pragma hdrstop

#include  "scanner.h"
#include	"st_layer.h"
#include  "m_layer.h"

HINSTANCE 	hModuleInstance;
int       	nX_Axis;
int       	nY_Axis;
HWND      	hControlWnd;

extern 	TCCDScan*		CCDScan;
extern	TImage*   	Image;

// Interface zu motors.dll
HINSTANCE  	hMDll = NULL;

int WINAPI LibMain(HINSTANCE inst,WORD,WORD,LPSTR)
	{
	hModuleInstance = inst;
	hMDll = GetModuleHandle("motors.dll");
	if(!hMDll)
		MessageBox(GetFocus(),"Bibliothek motors.dll nicht geladen !","Fehler",MBSTOP);
	return -1;
	};

int CALLBACK WEP(int)
	{
	return 1;
	};

BOOL WINAPI _export InitializeLineScanModule(HWND hcwnd)
	{
	hControlWnd = hcwnd;
	if(!mlIsAxisValid(X) || !mlIsAxisValid(Y))
		{
		MessageBox(GetFocus(),"Die Antriebe sind nicht Ok !","Fehler",MBINFO);
		}
	// check the calibration of xy-motors
	nX_Axis = mlGetIdByName(X);
	nY_Axis = mlGetIdByName(Y);
	mlSetAxis(nX_Axis);
	// do not change the following order
	if(CCDScan)
		delete CCDScan;
	CCDScan = (TCCDScan*)new TCCDScan();
	if(Image)
		delete Image;
	Image = (TImage*)new TImage();
	return TRUE;
	};

//******************************************************************************
//                         Interface
//******************************************************************************
BOOL WINAPI _export AquireOptimalExTime(void)
	{
	return CCDScan->AquireOptimalExTime();
	};

BOOL WINAPI _export SetLineScanParameters(void)
	{
	TModalDlg*	dlg;

	dlg = (TSetLineScanParameters *)new TSetLineScanParameters();
	dlg->ExecuteDialog(GetFrameHandle());
	delete dlg;
	return TRUE;
	};

BOOL _export WINAPI GetScanRanges(TFrameDimension* fd)
	{
	return CCDScan->GetScanRanges(fd);
	};

BOOL _export WINAPI SetImageSaveOptions(void)
	{
	TModalDlg* dlg;

	dlg = (TSetImageSaveOptions *)new TSetImageSaveOptions();
	dlg->ExecuteDialog(GetClientHandle());
	delete dlg;
	return TRUE;
	};

BOOL _export WINAPI GetHistogram(LPWORD* lpHist,int* len)
	{
	if(Image->InquireHistogram())
		return Image->GetHistogram(lpHist,len);
		else
		return FALSE;
	};

BOOL _export WINAPI InitializeAxis(int,LPSTR,int)
	{
	return TRUE; // InitializeAxis(mid,fn,addr);
	};

BOOL WINAPI _export InitializeTask(TScannerTask task)
	{
	switch(task) {
		case InquireCCDLine:
		GrabLineData();
		CCDScan->InquireLineParamters();
		return StartPolling(hControlWnd);

		case LineStepScan:
		CCDScan->ExecuteScan();
		break;
		}
	return FALSE;
	};

BOOL WINAPI _export ExecuteNextSubTask(TScannerTask task)
	{
	switch(task) {
		case InquireCCDLine:
		GrabLineData();
		CCDScan->InquireLineParamters();
		return StartPolling(hControlWnd);

		case StartCCDLineAgain:
		GrabLineData();
		// PostMessage(hControlWnd,WM_COMMAND,cm_CounterSet,0l);
		return TRUE;

		case LineStepScan:
		return CCDScan->StartPositioning();
		}
	return FALSE;
	};

BOOL WINAPI _export ReadOutCCD(int fkt)
	{
	TCCDScan::ReadOutCCD(fkt);
	return TRUE;
	};

BOOL WINAPI _export SaveImage(LPSTR fname)
	{
	return Image->SaveImage(fname);
	};

BOOL	WINAPI _export UnlockDataBase(void)
	{
	return Image->UnlockDataBase();
	};

BOOL	WINAPI _export GetDataBaseAccess(HPBYTE* hpDB,SIZE* size)
	{
	return Image->GetDataBaseAccess(hpDB,size);
	};

//******************************************************************************
// __LastLine__


